package com.huimv.guowei.admin.mqtt.moveScale;

import com.huimv.guowei.admin.entity.EnvMoveCall;
import com.huimv.guowei.admin.mapper.EnvMoveCallMapper;
import com.huimv.guowei.admin.service.IEnvMoveCallService;
import com.huimv.guowei.admin.utils.SpringUtil;
import org.eclipse.paho.client.mqttv3.IMqttDeliveryToken;
import org.eclipse.paho.client.mqttv3.MqttCallback;
import org.eclipse.paho.client.mqttv3.MqttMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

@Component
public class DataBack implements MqttCallback {

    @Autowired
    private EnvMoveCallMapper moveCallMapper;
    @Override
    public void connectionLost(Throwable cause) {

        // 连接丢失后，一般在这里面进行重连
        System.out.println("连接断开，可以做重连");
    }

    @Override
    public void deliveryComplete(IMqttDeliveryToken token) {
        System.out.println("deliveryComplete---------" + token.isComplete());
    }

    @Override
    public void messageArrived(String topic, MqttMessage message) throws Exception {
        // subscribe后得到的消息会执行到这里面
        System.out.println("接收消息主题 : " + topic);
        System.out.println("接收消息Qos : " + message.getQos());
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = new Date();
        System.out.println("接收时间：" + sdf.format(date));
        System.out.println("接收消息内容 : " + new String(message.getPayload()));

        System.out.println("开始处理数据：");
        String s = new String(message.getPayload());
        String[] split = s.split("\\+");
        String s1 = split[0];
        if (s1.equals("865328066116350")) {
            IEnvMoveCallService iEnvMoveCallService = SpringUtil.getBean(IEnvMoveCallService.class);
            System.out.println(s1);
            String s2 = split[1];
            String substring = s2.substring(0, 9);
            BigDecimal bg = new BigDecimal(substring);
            EnvMoveCall envMoveCall = new EnvMoveCall();
            envMoveCall.setCallDate(date);
            envMoveCall.setCallCode(s1);
            envMoveCall.setCallName("移动电子秤1");
            envMoveCall.setDuckWeight(bg);
            envMoveCall.setDuckNum("1");
            envMoveCall.setFarmId(21);
            iEnvMoveCallService.save(envMoveCall);
            System.out.println(bg);
            System.out.println("数据处理完成！");
        }
        if (s1.equals("865328063440043")) {
            IEnvMoveCallService iEnvMoveCallService = SpringUtil.getBean(IEnvMoveCallService.class);
            System.out.println(s1);
            String s2 = split[1];
            String substring = s2.substring(0, 9);
            BigDecimal bg = new BigDecimal(substring);
            EnvMoveCall envMoveCall = new EnvMoveCall();
            envMoveCall.setCallDate(date);
            envMoveCall.setCallCode(s1);
            envMoveCall.setCallName("移动电子秤2");
            envMoveCall.setDuckWeight(bg);
            envMoveCall.setDuckNum("2");
            envMoveCall.setFarmId(21);
            iEnvMoveCallService.save(envMoveCall);
            System.out.println(bg);
            System.out.println("数据处理完成！");
        }

    }


/*    public static void main(String[] args) {
        String s = "865328066116350+000.04000.00kg";
        String[] split = s.split("\\+");
        String s1 = split[0];
        System.out.println(s1);
        System.out.println(split[1]);
        String s2 = split[1];
        String substring = s2.substring(0, 9);
        System.out.println(substring);
        BigDecimal bg = new BigDecimal(substring);
        System.out.println(bg);


    }*/
}
